/* cftime --- an implementation of cftime to satisfy the ferret's uses */

# include <stdio.h>
# include <time.h>

cftime (char *buf, char *fmt, time_t *t)
{
	char tmp[256];
	char *src, *dst;
	struct tm *tptr;
	int ret;

	tptr = localtime (t);
	src = fmt;
	dst = buf;
	for (src = fmt; *src; ++src) {
		if (*src != '%')
			*dst++ = *src;
		else {
			++src;
			switch (*src) {
			case '%':
				*dst++ = '%';
				break;
			case 'T':
				sprintf (tmp, "%02d:%02d:%02d", tptr->tm_hour,
				    tptr->tm_min, tptr->tm_sec);
				strcpy (dst, tmp);
				dst += strlen (tmp);
				break;
			case 'D':
				sprintf (tmp, "%02d/%02d/%02d",
				    tptr->tm_mon+1, tptr->tm_mday,
				    tptr->tm_year);
				strcpy (dst, tmp);
				dst += strlen (tmp);
				break;
			default:
				fprintf (stderr,
				    "cftime: unknown conversion char '%c'\n",
				    *src);
				break;
			}
		}
	}
	*dst = 0;
	return (1);
}
