


ferret(local)                                                April 11, 1994



NAME
     ferret - find and catagorize SQL statements in source files

SYNOPSIS
     ferret [-s] [-y] [-p] [-v] [-d dbname] [-b basename] [-f listfile]
     [file] ...

DESCRIPTION
     ferret Scans input files for SQL statements, and produces various
     reports on the tables and columns it finds.  By default, ferret
     creates output files with "ferret" as the base name, and ".???" as the
     extension.  Each report has a different extension.  The following
     table relates the report to the file name extension:

                   __________________________________________
                    Report                         Extension
                   __________________________________________
                    Where Clause Summary           .wcs
                    Table/Column Cross Reference   .xrf
                    Join Cross Reference           .jrf
                    Error Summary                  .err
                    Warning Summary                .wrn
                    Optimizer Input File 	   .opt
                    Syntax Error                   .syn
                   __________________________________________


     -s        Produce the Syntax Error report.  By default, this report is
               not produced.

     -y        Print the actions of the parser on stdout.  This is intended
               for debugging only, and will probably disappear in a later
               release.

     -p        Print each stored DML on the stdout.  This is intended for
               debugging only.

     -v        Verbose: become very talkative in it's machinations.  Each
               input file name is printed when opened, and various other
               items of (presumed) interest.

     -d dbname      Sets ferret's idea of what the database name is.  The
               only place the dbname is currently used is in the ferret.opt
               file, as optimizedb refuses to allow the dbname on the
               command line.

     -b basename         Sets the basename of the output files.

     -f listfile         The files listed in listfile are used as input.
               The files are formatted one per line.

     file      At least one file or a listfile must be given as input.

     There is no restriction with mixing listfiles and other files as



Page 1                Pyramid DC/OSx Operating SystemPrinted April 10, 1994






ferret(local)                                                April 11, 1994



     input.

EXAMPLES
     ferret -s -b /tmp/caleb -d caleb *.osq *.rw *.sc
               Produces the files caleb.{syn,wcs,xrf,jrf,err,wrn,opt} in
               /tmp, outputs "caleb" as the first line in caleb.opt, and
               scans all the 4GL (*.osq), Report Writer (*.rw), and
               Embedded SQL C (*.sc) in the current directory.

     find . -name '*.osq' -print >list
     ferret -b /tmp/xyzzy -f list
               Produces the files xyzzy.{wcs,xrf,jrf,err.wrn.opt} in /tmp,
               and scans all of the files ending in ".osq" in this
               directory, or any sub directory.

FILES
     ferret.wcs     where clause summary output
     ferret.xrf     table/column cross reference
     ferret.jrf     join table/column cross reference
     ferret.err     Possible Cartesian Products, Join with OR, equi-column
     joins
     ferret.wrn     disimliar column names, functions in WHERE clause
     ferret.opt     optimizedb input (see -zf option for optimizedb)
     ferret.syn     optional syntax error file with entries the parser
     couldn't parse

NOTES
     ferret will produce complain about possible cartesian products on
     sub-selects when the sub-select contains unqualified column(s).

     ferret does not handle scope of correlation names.  It considers them
     global over an entire DML.  In the case of unions, for example, this
     is clearly wrong.  However, in practice, the same correlation names
     are used in all parts of the union, so this has not been a problem.





















Page 2                Pyramid DC/OSx Operating SystemPrinted April 10, 1994



