/* lex.c --- lexical things happen here */
/*
		Copyright 1994 In Touch Ministries
		Written by Daniel S. Cox (Danny@itm.org)


			   NO WARRANTY


  BECAUSE THIS PROGRAM IS LICENSED FREE OF CHARGE, WE PROVIDE ABSOLUTELY
NO WARRANTY, TO THE EXTENT PERMITTED BY APPLICABLE STATE LAW.  EXCEPT
WHEN OTHERWISE STATED IN WRITING, IN TOUCH MINISTRIES AND/OR OTHER
PARTIES PROVIDE THIS PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE
ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY
SERVICING, REPAIR OR CORRECTION.

 IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW WILL DANIEL S. COX,
IN TOUCH MINISTRIES, AND/OR ANY OTHER PARTY WHO MAY MODIFY AND
REDISTRIBUTE THIS PROGRAM AS PERMITTED BELOW, BE LIABLE TO YOU FOR
DAMAGES, INCLUDING ANY LOST PROFITS, LOST MONIES, OR OTHER SPECIAL,
INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY
TO USE (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
INACCURATE OR LOSSES SUSTAINED BY THIRD PARTIES OR A FAILURE OF THE
PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS) THIS PROGRAM, EVEN IF YOU
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES, OR FOR ANY CLAIM
BY ANY OTHER PARTY.


		GENERAL PUBLIC LICENSE TO COPY


  1. You may copy and distribute verbatim copies of this source file
as you receive it, in any medium, provided that you conspicuously and
appropriately publish on each copy a valid copyright notice "Copyright
1993 In Touch Ministries"; and include following the
copyright notice a verbatim copy of the above disclaimer of warranty
and of this License.  You may charge a distribution fee for the
physical act of transferring a copy.

  2. You may modify your copy or copies of this source file or
any portion of it, and copy and distribute such modifications under
the terms of Paragraph 1 above, provided that you also do the following:

    a) cause the modified files to carry prominent notices stating
    that you changed the files and the date of any change; and

    b) cause the whole of any work that you distribute or publish,
    that in whole or in part contains or is a derivative of this
    program or any part thereof, to be licensed at no charge to all
    third parties on terms identical to those contained in this
    License Agreement (except that you may choose to grant more extensive
    warranty protection to some or all third parties, at your option).

    c) You may charge a distribution fee for the physical act of
    transferring a copy, and you may at your option offer warranty
    protection in exchange for a fee.

Mere aggregation of another unrelated program with this program (or its
derivative) on a volume of a storage or distribution medium does not bring
the other program under the scope of these terms.

  3. You may copy and distribute this program or any portion of it in
compiled, executable or object code form under the terms of Paragraphs
1 and 2 above provided that you do the following:

    a) accompany it with the complete corresponding machine-readable
    source code, which must be distributed under the terms of
    Paragraphs 1 and 2 above; or,

    b) accompany it with a written offer, valid for at least three
    years, to give any third party free (except for a nominal
    shipping charge) a complete machine-readable copy of the
    corresponding source code, to be distributed under the terms of
    Paragraphs 1 and 2 above; or,

    c) accompany it with the information you received as to where the
    corresponding source code may be obtained.  (This alternative is
    allowed only for noncommercial distribution and only if you
    received the program in object code or executable form alone.)

For an executable file, complete source code means all the source code for
all modules it contains; but, as a special exception, it need not include
source code for modules which are standard libraries that accompany the
operating system on which the executable file runs.

  4. You may not copy, sublicense, distribute or transfer this program
except as expressly provided under this License Agreement.  Any attempt
otherwise to copy, sublicense, distribute or transfer this program is void and
your rights to use the program under this License agreement shall be
automatically terminated.  However, parties who have received computer
software programs from you with this License Agreement will not have
their licenses terminated so long as such parties remain in full compliance.

In other words, you are welcome to use, share and improve this program.
You are forbidden to forbid anyone else to use, share and improve
what you give them.   Help stamp out software-hoarding!
*/

# include <stdio.h>
# include <ctype.h>
# include <string.h>
# include "ferret.h"
# include "store.h"
# ifdef VMS
# 	include "y_tab.h"
# else
#	include "y.tab.h"
# endif

static unsigned char Identch[128] = {
/* NUL ^A ^B ^C ^D ^E ^F ^G ^H ^I ^J ^K ^L ^M ^N ^O */
     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/*  ^P ^Q ^R ^S ^T ^U ^V ^W ^X ^Y ^Z ^[ ^\ ^] ^^ ^_ */
     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/*     !   "  #  $  %  &  '  (  )  *  +  ,  -  .  / */
     0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0,
/*   0  1  2  3  4  5  6  7  8  9  :  ;  <  =  >  ? */
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0,
/*   @  A  B  C  D  E  F  G  H  I  J  K  L  M  N  O */
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/*   P  Q  R  S  T  U  V  W  X  Y  Z  [  \  ]  ^  _ */
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1,
/*   `  a  b  c  d  e  f  g  h  i  j  k  l  m  n  o */
     0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/*   p  q  r  s  t  u  v  w  x  y  z  {  !  }  ~ ^? */
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0,
};
static unsigned char Beginch[128] = {
/* NUL ^A ^B ^C ^D ^E ^F ^G ^H ^I ^J ^K ^L ^M ^N ^O */
     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/*  ^P ^Q ^R ^S ^T ^U ^V ^W ^X ^Y ^Z ^[ ^\ ^] ^^ ^_ */
     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
/*     !   "  #  $  %  &  '  (  )  *  +  ,  -  .  / */
     0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0,
/*   0  1  2  3  4  5  6  7  8  9  :  ;  <  =  >  ? */
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0,
/*   @  A  B  C  D  E  F  G  H  I  J  K  L  M  N  O */
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/*   P  Q  R  S  T  U  V  W  X  Y  Z  [  \  ]  ^  _ */
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1,
/*   `  a  b  c  d  e  f  g  h  i  j  k  l  m  n  o */
     0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
/*   p  q  r  s  t  u  v  w  x  y  z  {  !  }  ~ ^? */
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0,
};

# define isidentch(c)   (Identch[c])
# define isbeginch(c)   (Beginch[c])

static int state = SKIMMING;

extern char *progname;
extern int  lineno;
extern char *Fname;
extern FILE *Fin;

extern int yydebug;

static int follow (int, int, int);
static int follow2 (int, int, int, int, int);
extern void yyerror (char *);
extern int identify (char *);
static void error (char *, char *);

int
yylex ()
{
    register int c;
    register char *p, *litmax;
    static char litbuf[2048];

    litmax = litbuf + sizeof (litbuf) - 1;
    for (;;) {
	while ((c = getc (Fin)) == ' ' || c == '\t')
	    ;
	if (c == '\n') {
	    ++lineno;
	    continue;
	}
	else if (c == EOF) {
	    return (0);
	}
	
	/* comment */
	else if (c == '/') {
	    if ((c = getc (Fin)) != '*') {
		ungetc (c, Fin);
		c = '/';
	    }
	    else {
		for (;;) {
		    if ((c = getc (Fin)) == EOF)
			error ("unexpected EOF in comment", "");
		    else if (c == '*') {
			if ((c = getc (Fin)) == '/')
			    break;
			else {
			    ungetc (c, Fin);
			    c = '*';
			}
		    }
		    else if (c == '\n') {
			++lineno;
		    }
		}
		continue;
	    }
	}
	if (c == '\'' || c == '"') {    /* string */
	    int lookfor = c;
	    for (p = litbuf; (c = getc (Fin)) != lookfor; p++) {
		if (Filetype == CSRC && c == '\\') {
		    int c1;
		    c1 = getc (Fin);
		    if (c1 == EOF) {
			*p = 0;
			error ("unexpected EOF in string", litbuf);
		    }
		    if (c1 == '\n') {
			++lineno;
			continue;   /* discard "\ newline" */
		    }
		    else
			*p = c;
		}
		else if (c == '\n' || c == EOF) {
		    *p = 0;
		    error ("unexpected newline in string", litbuf);
		}
		if (p > litmax) {
		    *p = 0;
		    error ("string too long", litbuf);
		}
		*p = c;
	    }
	    *p = 0;
	    if (state == SKIMMING)
		continue;
	    else {
		yylval.lit = strdup (litbuf);
		return (LITERAL);
	    }
	}
	
	/* skip any chars that are outside the range of the tables */
	if (c < 0 || c >= 128)
	    continue;
	
	/* KEYWORD, IDENT, or LITERAL */
	if (isbeginch (c)) {
	    int tok;
	    p = litbuf;
	    for (;;) {
		if (p > litmax) {
		    *p = 0;
		    error ("KEYWORD/IDENT/LITERAL too long", litbuf);
		}
		*p++ = c;
		if ((c = getc (Fin)) == EOF) {
		    *p = 0;
		    error ("unexpected EOF in ident/lit", litbuf);
		}
		if (!isidentch (c))
		    break;
	    }
	    ungetc (c, Fin);
	    *p = 0;
	    tok = identify (litbuf);
	    if (tok == SELECT || tok == INSERT ||
	      tok == DELETE || tok == UPDATE) {
		state = LEXING;
		yylval.floc = emalloc (sizeof (fileloc_t));
		yylval.floc->fname = strdup (Fname);
		yylval.floc->lineno = lineno;
		return (tok);
	    }
		
	    if (state == SKIMMING)
		continue;
	    else {
		yylval.lit = strdup (litbuf);
		if (yydebug)
		    printf ("*** lex passes \"%s\"\n", litbuf);
		return (tok);
	    }
	}
	if (state == SKIMMING)
	    continue;
	
	switch (c) {
	case '>':       return (follow ('=', GE, GT));
	case '<':       return (follow2 ('=', LE, '>', NE, LT));
	case '!':       return (follow ('=', NE, '!'));
	case '*':       return (follow ('*', EXPON, '*'));
	case '=':       return (EQ);
	case '-':       return (follow ('>', CPTR, '-'));
	default:        return (c);
	}
    }
}

/* follow --- look ahead for >=, etc. */

static int
follow (int expect, int ifyes, int ifno)
{
    register int c = getc (Fin);

    if (c == expect)
	return (ifyes);

    ungetc (c, Fin);
    return (ifno);
}

/* follow2 --- determine <=, <>, < */

static int
follow2 (int c1, int ifc1, int c2, int ifc2, int aint)
{
    int c = getc (Fin);

    if (c == c1)
	return (ifc1);
    else if (c == c2)
	return (ifc2);

    ungetc (c, Fin);
    return (aint);
}

/* yyerror --- save the syntax errors for reporting later */

void
yyerror (char *mesg)
{
    extern syntax_t *Syntax_l;
    syntax_t *s;

    s = emalloc (sizeof (syntax_t));
    s->fname = strdup (Fname);
    s->lineno = lineno;
    s->next = Syntax_l;
    Syntax_l = s;
}

/* error --- report error from lexer */

static void
error (char *s, char *t)
{
    FILE *err = stdout;

    fprintf (err, "%s: %s", progname, s);

    if (t && *t)
	fprintf (err, " %s", t);

    fprintf (err, " near line %d\n", lineno);
}

/* set_lex_skim --- set state back to SKIMMING */

void
set_lex_skim ()
{
    state = SKIMMING;
}
